package org.nakedobjects.nof.reflect.java.annotations;

import java.util.List;

import org.nakedobjects.applib.annotation.ActionOrder;
import org.nakedobjects.applib.annotation.Bounded;
import org.nakedobjects.applib.annotation.Debug;
import org.nakedobjects.applib.annotation.DescribedAs;
import org.nakedobjects.applib.annotation.Disabled;
import org.nakedobjects.applib.annotation.Executed;
import org.nakedobjects.applib.annotation.Exploration;
import org.nakedobjects.applib.annotation.FieldOrder;
import org.nakedobjects.applib.annotation.Hidden;
import org.nakedobjects.applib.annotation.Immutable;
import org.nakedobjects.applib.annotation.MultiLine;
import org.nakedobjects.applib.annotation.Named;
import org.nakedobjects.applib.annotation.NotPersisted;
import org.nakedobjects.applib.annotation.Optional;
import org.nakedobjects.applib.annotation.Plural;
import org.nakedobjects.applib.annotation.TypeOf;


@Bounded
@ActionOrder("1, 2, 3")
@FieldOrder("4, 5, 6")
@Immutable
@Named("singular name")
@Plural("plural name")
public class JavaObjectForReflectorWithExtensions {

    
    public void actionMethod(@Named("one")
            @Optional String param) {}

    @Debug
    public void debugMethod() {}

    @Exploration
    public void explorationMethod() {}

    @Hidden
    public void hiddenMethod() {}

    @NotPersisted
    public int getOne() {
        return 1;
    }

    public void setOne(int value) {}
    
    @Disabled
    public String getTwo() {
        return "";
    }

    @TypeOf(Long.class)
    @DescribedAs("description text")
    @Named("name text")
    public List getCollection() {
        return null;
    }

    @Executed(Executed.Where.LOCALLY)
    public void localMethod() {}

    @Executed(Executed.Where.REMOTELY)
    public void remoteMethod() {}

    @Disabled
    public void unusableMethod() {}
    
    public void actionWithStringParams(
            String notMultiline, 
            @MultiLine(numberOfLines=10)
            String multiLine) {}


}

// Copyright (c) Naked Objects Group Ltd.
