package org.nakedobjects.nof.reflect.java.reflect;

import java.lang.reflect.Method;
import java.util.HashSet;

import junit.framework.TestCase;

import org.apache.log4j.Level;
import org.apache.log4j.Logger;
import org.nakedobjects.noa.reflect.Consent;
import org.nakedobjects.nof.reflect.peer.MemberIdentifier;
import org.nakedobjects.nof.reflect.peer.MemberIdentifierImpl;
import org.nakedobjects.nof.testsystem.TestPojo;
import org.nakedobjects.nof.testsystem.TestProxyNakedObject;
import org.nakedobjects.nof.testsystem.TestProxySystem;


public class JavaSetTest extends TestCase {

    private TestProxySystem system;
    private JavaSet listField;
    private TestObjectWithCollection testPojo;
    private TestProxyNakedObject testAdapter;
    private HashSet collection;
    private TestProxyNakedObject element;

    protected void setUp() throws Exception {
        Logger.getRootLogger().setLevel(Level.OFF);

        system = new TestProxySystem();
        system.init();

        Class cls = TestPojo.class;

        Method getMethod = TestObjectWithCollection.class.getMethod("getList", new Class[0]);

        MemberIdentifier identifer = new MemberIdentifierImpl(TestObjectWithCollection.class.getName());
        FieldMethods fieldMethods = new FieldMethods(getMethod, null);
        FieldFlags fieldFlags = new FieldFlags(null, false, null, true, "");
        GeneralControlMethods controlMethods = new GeneralControlMethods(null, null, null, null);
        MemberHelper nameHelper = new StaticHelper("list");
        DescriptiveMethods descriptiveMethods = new DescriptiveMethods(nameHelper, null);
        MemberSessionMethods sessionMethods = new MemberSessionMethods(null, null);

        listField = new JavaSet(identifer, cls, descriptiveMethods, fieldMethods, controlMethods, fieldFlags, null,
                sessionMethods);

        element = system.createPersistentTestObject();
        collection = new HashSet();
        collection.add(element.getObject());
        testPojo = new TestObjectWithCollection(collection, false);
        testAdapter = system.createPersistentTestObject(testPojo);
    }

    public void testAddAllowed() throws Exception {
        TestProxyNakedObject element = system.createPersistentTestObject();
        Consent consent = listField.isAddValid(testAdapter, element);
        assertEquals(true, consent.isAllowed());
    }

    public void testAddVetoedAsItIsADuplicate() throws Exception {
        Consent consent = listField.isAddValid(testAdapter, element);
        assertEquals(false, consent.isAllowed());
    }
    
    public void testSize() throws Exception {
    assertEquals(1, collection.size());
    }
}

// Copyright (c) Naked Objects Group Ltd.
