/**
 * 
 */
package org.nakedobjects.nof.reflect.java.reflect;

import org.nakedobjects.noa.adapter.NakedReference;
import org.nakedobjects.noa.reflect.Consent;
import org.nakedobjects.noa.security.Session;
import org.nakedobjects.nof.core.reflect.Allow;
import org.nakedobjects.nof.core.util.DebugString;
import org.nakedobjects.nof.reflect.peer.MemberIdentifier;
import org.nakedobjects.nof.reflect.peer.MemberIdentifierImpl;
import org.nakedobjects.nof.reflect.peer.MemberPeer;


final class MemberPeerStub extends DefaultExtensionHolderMutable implements MemberPeer {
    
    public MemberPeerStub(String name) {
        super(name);
    }

    public void debugData(DebugString debugString) {}

    public String getHelp() {
        return null;
    }

    public MemberIdentifier getIdentifier() {
        return new MemberIdentifierImpl(null) {
            @Override
            public String toString() {
                return MemberPeerStub.this.getName();
            }
        };
    }

    public Consent isUsableDeclaratively() {
        return Allow.DEFAULT;
    }

    public Consent isUsableForSession(
            Session session) {
        return Allow.DEFAULT;
    }

    public Consent isUsable(NakedReference target) {
        return null;
    }
    
    public boolean isVisibleDeclaratively() {
        return false;
    }

    public boolean isVisibleForSession(
            Session session) {
        return false;
    }

    public boolean isVisible(NakedReference target) {
        return false;
    }
    
    @Override
    public String toString() {
        return getName();
    }
    
}
