package org.nakedobjects.nof.reflect.java.reflect;

import org.nakedobjects.nof.testsystem.TestPojo;


public class TestObjectWithCollection extends TestPojo {
    private final Object arrayList;
    private Object added;
    private Object removed;
    private final boolean throwException;
    private boolean clearCalled;

    public TestObjectWithCollection(Object arrayList, boolean throwException) {
        this.arrayList = arrayList;
        this.throwException = throwException;
    }

    public Object getList() {
        throwException();
        return arrayList;
    }

    public void addToList(Object object) {
        throwException();
        this.added = object;
    }

    private void throwException() {
        if(throwException) {
            throw new Error("cause invocation failure");
        }
    }
    
    public void removeFromList(Object object) {
        throwException();
        removed = object;
    }

    public void clearList() {
        throwException();
        clearCalled = true;
    }
    
    public String validateAddToList(Object object) {
        throwException();
        if (object instanceof TestObjectWithCollection) {
            return "can't add this type of object";
        } else {
            return null;
        }
    }

    public Object getAdded() {
        return added;
    }

    public Object getRemoved() {
        return removed;
    }

    public boolean getClear() {
        return clearCalled;
    }

}

// Copyright (c) Naked Objects Group Ltd.
