package org.nakedobjects.nof.reflect.java.value;

import org.nakedobjects.applib.value.Percentage;
import org.nakedobjects.nof.core.adapter.value.AbstractValueAdapterTestCase;

public class PercentageAdapterTest extends AbstractValueAdapterTestCase {
    PercentageAdapter adapter;
        
    protected void setUp() throws Exception {
        super.setUp();
        super.value = adapter = new PercentageAdapter(new Percentage(0.105f));
    }

    public void testAsEncodedString() {
        String encoded = new String(adapter.asEncodedString());
        assertEquals("0.105", encoded);
    }

    public void testParseTextEntryWithNumber() {
        adapter.parseTextEntry("21%");
        assertEquals(0.21f, adapter.floatValue(), 0.0f);
    }


    public void testParseTextEntryWithNumberAndDecimalPoint() {
        adapter.parseTextEntry("21.4%");
        assertEquals(0.214f, adapter.floatValue(), 0.0f);
    }


    public void testParseTextEntryWithBlank() {
        adapter.parseTextEntry("");
        assertTrue(adapter.isEmpty());
    }

    public void testRestoreFromEncodedString() {
        adapter.restoreFromEncodedString("0.2134");
        assertEquals(0.2134f, adapter.floatValue(), 0.0f);
    }

    public void testTitleString() {
        assertEquals("10%", adapter.titleString());
    }

    public void testFloatValue() {
        assertEquals(0.105f, adapter.floatValue(), 0.0f);
    }

}


// Copyright (c) Naked Objects Group Ltd.
