package org.nakedobjects.nof.reflect.java.value;

import org.nakedobjects.applib.value.TestClock;
import org.nakedobjects.applib.value.TimeStamp;
import org.nakedobjects.nof.core.adapter.value.AbstractValueAdapterTestCase;


public class TimeStampAdapterTest extends AbstractValueAdapterTestCase {

    private TimeStampAdapter adapter;

    protected void setUp() throws Exception {
        super.setUp();
        TestClock.initialize();
        super.value = adapter = new TimeStampAdapter(new TimeStamp(0));
    }

    public void testParseNull() {
    // skip this test
    }

    public void testParseEmptyString() {
    // skip this test
    }

    public void testNotEmpty() {
        assertFalse(adapter.isEmpty());
    }

    public void testEmpty() {
        TimeStampAdapter adapter = new TimeStampAdapter();
        assertTrue(adapter.isEmpty());
    }

    public void testZero() {
        assertEquals(0, adapter.timeValue().getTime());
    }

    public void testTitle() {
        assertEquals("01/01/70 00:00:00 UTC", adapter.titleString());
    }

    public void testEncodesEmptyTimeStamp() {
        TimeStampAdapter adapter = new TimeStampAdapter();
        String encodedString = new String(adapter.asEncodedString());
        assertEquals("NULL", encodedString);
    }

    public void testEncodesTimeStamp() {
        TimeStampAdapter adapter = new TimeStampAdapter(new TimeStamp());
        String encodedString = new String(adapter.asEncodedString());
        assertEquals("20030817T213025000", encodedString);
    }

    public void testDecodesNull() {
        TimeStampAdapter adapter = new TimeStampAdapter(new TimeStamp());
        String encodedString = "NULL";
        adapter.restoreFromEncodedString(encodedString);
        assertTrue(adapter.isEmpty());
    }

    public void testDecodesTimeStamp() {
        TimeStampAdapter adapter = new TimeStampAdapter(new TimeStamp());
        String encodedString = "19700101T000000000";
        adapter.restoreFromEncodedString(encodedString);
        assertEquals(0L, adapter.timeValue().getTime());
    }
}

// Copyright (c) Naked Objects Group Ltd.
